function[Satisfied, Edges, TotalSat, TotalLam, t,Worked]=Quenched(Lambdamu,Lambdasig,Links,NoOfSteps)

Small=0.000000001;
Infi=10000000000;
eqCount=0;
N=length(Lambdamu);
E=length(Links);

%Writing the Links vector as a Matrix of connections
[NeighbourM,NeighbourCM,NeighbourICon]=zMakeNeighbourMatrix(N, Links);

%Starting values of A, B and Y
Max=max(NeighbourICon);
A=zeros(N,Max);
B=ones(N,Max);
Y=zeros(N,Max);

[Randi]=zRandomlyChooseJ(Links,NoOfSteps,N);

for t=1:NoOfSteps*N
   
    %Assigning Nodes J and I
    nodeJ=Randi(1,t);
    connectivity=NeighbourICon(nodeJ);
    nodeI=Randi(2,t);
    cavityI=find(NeighbourM(nodeJ,:)==nodeI);
    cavityJ=find(NeighbourM(nodeI,:)==nodeJ);
    
    %Rewriting for ease
    Yij=Y(nodeI,cavityJ);
    Yji=Y(nodeJ,cavityI);
    Aij=A(nodeI,cavityJ);
    Aji=A(nodeJ,cavityI);
    Bij=B(nodeI,cavityJ);
    Bji=B(nodeJ,cavityI);
    mu=Lambdamu(nodeJ);
    sig=Lambdasig(nodeJ);
    Phiij1=Y(nodeI,cavityJ);%Assuming quadratic transportation cost
    Phiij2=1;%Assuming quadratic transportation costs w. no resistance
    
    %Obtaining values of A, B and Y from descendants k
    for k=1:connectivity
        Ajk(k)=A(nodeJ,k);
        Bjk(k)=B(nodeJ,k);
        Yjk(k)=Y(nodeJ,k);
        Phijk1(k)=Y(nodeJ,k); %*
        Phijk2(k)=1; %*
    end
    
    %Summing the descendants for calculations in mu
    tempd1=0;
    tempd2=0;
    
    for k=1:connectivity
        if k~=cavityI
            tempd1=tempd1+Yjk(k)-((Ajk(k)+Phijk1(k))/(Bjk(k)+Phijk2(k)));
            tempd2=tempd2+(1/(Phijk2(k)+Bjk(k)));
        end
    end
    
    %Calculating Mu
    x=Yij-tempd1;
    S2=sqrt(2);
    SP=sqrt(pi);
    z=(x-mu)/(S2*sig);
    ERF=erf(z);
    EXP=exp(-(z^2));
    
    if sig==0
        if x-mu>0
            ERF=1;
        elseif x-mu<0
            ERF=-1;
        else
            ERF=1;
        end
        EXP=0;
    end    

    tempmu=(((mu-x)*(ERF+1))-((S2*sig*EXP)/(SP)))/(2*tempd2);

    %Messages before changing to check convergence
    preA=Aij;
    preB=Bij;
    preY=Yij;

    %Calculating new Aij and Bij
    A(nodeI,cavityJ)=-tempmu;
    B(nodeI,cavityJ)=(ERF+1)/(2*tempd2);
    Aij=A(nodeI,cavityJ); %ease
    Bij=B(nodeI,cavityJ); %ease
    
    %Calculating new Yij
    Y(nodeI,cavityJ)=(((Bij*Yij)-Aij-(Bji*Yji)+Aji-Phiij1+(Phiij2*Yij))/(Bij+Bji+Phiij2));

    %ConvergenceCheck
    fieldChange=abs(A(nodeI,cavityJ)-preA)+abs(B(nodeI,cavityJ)-preB)+abs(Y(nodeI,cavityJ)-preY);

    if fieldChange<Small
        eqCount=eqCount+1;
    else
        eqCount=0;
    end
    
    %Finish if converged.
    if eqCount>E*4
        fprintf('Break at %5.0f Iterations for N=%3.0f \n',t,N);
        break;
    end
    
end

[Satisfied,TotalSat,TotalLam,Given]=zCheck(Lambdamu,Y,NeighbourICon,Small);
[Edges]=zShowYAsEdgesEdges(Links,Y,NeighbourM,NeighbourCM,Small);
Worked=sum(abs(Edges(:,3)-Edges(:,4)))>0.001;
Worked=Worked+heaviside(sum(isnan(Edges(:,3)))-0.001);
Worked=Worked+heaviside(sum(Satisfied<-0.001)-0.00001);
Worked=Worked+(abs(TotalLam-TotalSat)>0.001);


end

%* Change these is quadratic transportation cost changes.